__package__    = "darwin.py"
__version__    = "1.1"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/growler/"
__cvsversion__ = "$Revision: 1.2 $"
__date__       = "$Date: 2008/01/04 06:23:47 $"
__copyright__  = "Copyright (c) 2007 Aaron Straup Cope. Perl Artistic License."

# http://www.opensource.apple.com/darwinsource/Current/pyobjc-14/pyobjc/sandbox/pyobjc-framework-IOBluetooth/Examples/BluetoothInquiryExample/BluetoothExplorerWindow.py
# http://developer.apple.com/documentation/DeviceDrivers/Reference/IOBluetooth/IOBluetoothDeviceInquiry/Classes/IOBluetoothDeviceInquiry_/index.html

kIOReturnSuccess = 0
from IOBluetooth import *
import time

class probe () :

    def is_device_nearby (self, address, timeout=15) :

        timeout = timeout * 1000
        
        conn = IOBluetooth.IOBluetoothDevice.withAddressString_(address)
        status = conn.remoteNameRequest_withPageTimeout_(None, timeout)

        if status != kIOReturnSuccess :
            return False

        return True
    
    #
    
    def finddevices (self, timeout=15) :
        
        inq = IOBluetoothDeviceInquiry.inquiryWithDelegate_(self)

        # is this what makes os x unhappy when
        # called by multiple (growler) apps?
        # inq.clearFoundDevices()
        
        inq.setInquiryLength_(timeout)
        inq.setUpdateNewDeviceNames_(False)
        
        status = inq.start()
        
	counter = 0
	
        if status == kIOReturnSuccess :

            while counter < timeout :
            	counter += 1
            	time.sleep(1) 
                
        inq.stop()

        found = {}
        
        for d in inq.foundDevices() :
            addr = d.getAddressString()
            name = d.getName()            

            addr = addr.replace("-", ":")
            found[addr] = name

        return found

    
