__package__    = "utils.py"
__version__    = "1.1"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/growler/"
__cvsversion__ = "$Revision: 1.2 $"
__date__       = "$Date: 2008/01/04 06:23:46 $"
__copyright__  = "Copyright (c) 2007 Aaron Straup Cope. Perl Artistic License."

import sgmllib
import os
import os.path
import re
import time as pytime

class filesystem :

    # http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/82465
    
    def mkdir(self, newdir):

        if os.path.isdir(newdir):
            pass
        elif os.path.isfile(newdir):
            raise Exception, "%s already exists" % newdir
        else:
            head, tail = os.path.split(newdir)
            if head and not os.path.isdir(head):
                self.mkdir(head)
            if tail:
                os.mkdir(newdir)

    def prunedir (self, dir, age='1w') :
        pass
            
class markup (sgmllib.SGMLParser) :

    def __init__(self):
        sgmllib.SGMLParser.__init__(self)

    def strip(self, some_html):
        self.theString = ""
        self.feed(some_html)
        self.close()
        return self.theString

    def handle_data(self, data):
        self.theString += data

class time :

    def parse_date (self, str, as_seconds=True) :

        try :
            import feedparser
        except Exception, e :
            return None
        
        t = feedparser._parse_date(str)

        if not as_seconds :
            return t

        return pytime.strftime("%s", t)

    #
    
    def parse_timestring (self, str) :

        re_timestring = re.compile(r"^(\d+)([hdwM])$")
        match = re_timestring.match(str)

        if not match :
            return None

        (count, period) = match.groups()

        count = int(count)
        hour = (60 * 60)
        
        if period == 'h' :
            return count * hour

        if period == 'd' :
            return count * (24 * hour)

        if period == 'w' :
            return count * (7 * 24 * hour)

        if period == 'M' :
            return count * (4 * 7 * 24 * hour)

        return None
